function init()
	excavator = FindVehicle("excavator")

	direction = nil
	
	baseMotor = FindJoint("excavatorBase")
	arm1Motor = FindJoints("excavatorArm1")
	arm2Motor = FindJoints("excavatorArm2")
	bracketMotor = FindJoints("excavatorBracket")
	motorTable = {baseMotor, arm1Motor, arm2Motor, bracketMotor}
	
	base_spd = 0.5
	arm1_spd = 0.5
	arm2_spd = 1.0
	bracket_spd = 1.2
	
	uiCaption = {'Excavator Commands'}
	uiHotkeys = {{'Left/Right Arrow', 'Pivot Chassis'}, {'Up/Down Arrow', 'Lift Arm&Bracket'}}
end


function MotorInitialize()
	SetJointMotor(baseMotor, 0)
	for i=1,#arm1Motor do
		SetJointMotor(arm1Motor[i], 0)
	end
	for i=1,#arm2Motor do
		SetJointMotor(arm2Motor[i], 0)
	end
	for i=1,#bracketMotor do
		SetJointMotor(bracketMotor[i], 0)
	end
end

function Pivot(directionP)
	if directionP == 'CW' then
		SetJointMotor(baseMotor, -base_spd)
	elseif directionP == 'CCW' then
		SetJointMotor(baseMotor, base_spd)
	end
end

function Lift(direction)
	if direction == 'up' then
		for i=1,#arm1Motor do
			SetJointMotor(arm1Motor[i], -arm1_spd)
		end
		for i=1,#arm2Motor do
			SetJointMotor(arm2Motor[i], -arm2_spd)
		end
		for i=1,#bracketMotor do
			SetJointMotor(bracketMotor[i], -bracket_spd)
		end
	elseif direction == 'down' then
		for i=1,#arm1Motor do
			SetJointMotor(arm1Motor[i], arm1_spd)
		end
		for i=1,#arm2Motor do
			SetJointMotor(arm2Motor[i], arm2_spd)
		end
		for i=1,#bracketMotor do
			SetJointMotor(bracketMotor[i], bracket_spd)
		end
	end
end

function tick(dt)
	if GetPlayerVehicle() == excavator then
		if InputDown("c") then
			directionP = 'CCW'
			Pivot(directionP)
		elseif InputDown("z") then
			directionP = 'CW'
			Pivot(directionP)
		
		elseif InputDown("lmb") then
			direction = 'up'
			Lift(direction)
		elseif InputDown("rmb") then
			direction = 'down'
			Lift(direction)
			
		else
			MotorInitialize()
		end
	end

end